=== libfutils/threadx/Makefile ===
libfutils-objs += ../src/timetools.o

obj-y += libfutils.a
install-files += libfutils.a
