=== ulog/kernel/Makefile ===
obj-m += ulogger.o
